unit skyperfecMain;
{TODO:PackMemőN̓e}
{TODO:JeS(X|[cAfAyȂ)\ƃ\[g}
{TODO:CS110̂Ƃ̃`l\[g}
{TODO:ʃpbNŗ]Ɍ悤ɂȂ`l悤}
{TODO:`lXg̑IUIČ}
{TODO:Ƃɂx̂ǂɂ}
{TODO:pbNPʂ̕\`lI}
{TODO:JeSPʂ̕\`lI}
{TODO:ʂhtmlɂăt@CAuEUN? łłt@C̎c[ǂ? ނhttpT[o[ɂȂׂ?}
{TODO:ςweb service? ajax? }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, skyperfdata, Spin, contnrs, ExtCtrls;

type
  TSkyPerfecForm = class(TForm, IMessageCallback)
    Panel1: TPanel;
    ResultView: TMemo;
    PackMemo: TMemo;
    Splitter1: TSplitter;
    TopPanel: TPanel;
    CalcButton: TButton;
    Label3: TLabel;
    SpinEdit1: TSpinEdit;
    Label2: TLabel;
    SelCountLabel: TLabel;
    ResetButton: TButton;
    Panel2: TPanel;
    ListView2: TListView;
    ListView1: TListView;
    Splitter2: TSplitter;
    Splitter3: TSplitter;
    procedure ListView1ColumnClick(Sender: TObject; Column: TListColumn);
    procedure FormCreate(Sender: TObject);
    procedure CalcButtonClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure ListView1Compare(Sender: TObject; Item1, Item2: TListItem;
      Data: Integer; var Compare: Integer);
    procedure ResetButtonClick(Sender: TObject);
    procedure ListView1Change(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure ListView2Change(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ListView1InfoTip(Sender: TObject; Item: TListItem;
      var InfoTip: String);
  private
    { Private 錾 }
    FCalc: TSkyPerfCalc;
    FRequest: TRequest;
    FResults: TObjectList;
    FLoaded: boolean;
    FUpdatingListViews: integer;
    FListView1SortKey: integer;
    procedure Calculate;
    procedure SetSort(column: integer);
    procedure UpdateSelCount;
    procedure UpdateServiceListView;
    procedure UpdateChannelListView;
    procedure BeginUpdateListViews;
    procedure EndUpdateListViews;
    function MakeHint(ch: TChannel): string;

  public
    { Public 錾 }
    procedure DumpPacks;
    procedure AddLine( s: string );
  end;

const
  DataFileName = 'sel.txt';

var
  SkyPerfecForm: TSkyPerfecForm;

implementation
uses
  mmsystem, math,
  ProgressDlg;

{$R *.DFM}

procedure TSkyPerfecForm.FormCreate(Sender: TObject);
  function LoadSel: string;
  var
    ss: TStringStream;
    fs: TFileStream;
    fn: string;
  begin
    fn := ExtractFilePath(ParamStr(0)) + PathDelim + DataFileName;
    result := '';
    if FileExists(fn) then
    begin
      ss := TStringStream.Create('');
      try
        fs := TFileStream.Create( fn, fmOpenRead );
        try
          ss.CopyFrom( fs, fs.Size );
        finally
          fs.Free;
        end;
        result := ss.DataString;
      finally
        ss.Free;
      end;
    end;
  end;

var
  sl: TStringList;
  j: integer;
  ch: TChannel;
  chnum: integer;
  there: boolean;

  data: TStringList;
  filename: string;
begin
  FListView1SortKey := 0;
  ResultView.Clear;
  ResultView.Lines.Append( 'read start.' );
  filename := ExtractFilePath(ParamStr(0)) + PathDelim + 'skyperfectv.txt';
  data := TStringList.Create;
  try
    data.LoadFromFile( filename );
    FCalc := TSkyPerfCalc.Create( self, data, filename );
  finally
    data.Free;
  end;
  ResultView.Lines.Append( FCalc.DataVersionComment );
  ResultView.Lines.Append( 'done.' );

  FRequest := FCalc.CreateRequest;
  FRequest.ClearSelections;
  FRequest.DisableAllServices;

//  DumpPacks;
  // Load sel.txt
  there := false;
  sl := TStringList.Create;
  try
    sl.Text := LoadSel;
    for j := 0 to sl.Count-1 do
    begin
      chnum := StrToInt(sl[j]);
      ch := FCalc.FindChannel(chnum);
      if ch <> nil then
      begin
        FRequest.SetRequest(ch, AnyService);
        FRequest.SetServiceEnabled(ch.Service, true);
        there := true;
      end;
    end;
  finally
    sl.Free;
  end;

  // ŏ͂ЂƂ`lIĂȂ߁AT[rXXgS
  // `lXgŃrbN̂
  // ЂƂIĂȂƂ͑SLɂĂ
  if not there then
    FRequest.EnableAllServices;

  BeginUpdateListViews;
  try
    UpdateServiceListView;
    UpdateChannelListView;
  finally
    EndUpdateListViews;
  end;

  ResultView.Lines.Append( 'ready.' );
  FLoaded := true;
  FRequest.Modified := false;
end;

procedure TSkyPerfecForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
  function GetSelectedChannelsText: string;
  var
    sl: TStringList;
    s: integer;
    service: TService;
    c: integer;
    channel: TChannel;
  begin
    result := '';
    sl := TStringList.Create;
    try
      for s := 0 to FCalc.ServiceCount-1 do
      begin
        service := FCalc.Services[s];
        for c := 0 to service.ChannelCount-1 do
        begin
          channel := service.Channels[c];
          case FRequest.GetRequest(channel) of
          DontCare:
            ;
          AnyService:
            sl.Append(IntToStr(channel.Num));
          end;
        end;
      end;
      result := sl.Text;
    finally
      sl.Free;
    end;
  end;

  procedure SaveFile( const filename, content: string );
  var
    ss: TStringStream;
    fs: TFileStream;
  begin
    ss := TStringStream.Create(content);
    try
      fs := TFileStream.Create( filename, fmCreate );
      try
        fs.CopyFrom( ss, ss.Size );
      finally
        fs.Free;
      end;
    finally
      ss.Free;
    end;
  end;
var
  filename: string;
begin
  filename := ExtractFilePath(ParamStr(0)) + PathDelim + DataFileName;

  CanClose := true;
  if FLoaded and FRequest.Modified then
  begin
    case MessageDlg('`lIɕύX܂B'+DataFileName+' ɕۑ܂?', mtConfirmation, mbYesNoCancel, 0) of
    mrYes:
      begin
        SaveFile(filename, GetSelectedChannelsText);
        FRequest.Modified := false;
      end;
    mrCancel:
      CanClose := False;
    end;
  end;
end;

procedure TSkyPerfecForm.FormDestroy(Sender: TObject);
begin
  if FResults <> nil then
  begin
    FreeAndNil(FResults);
  end;
  FRequest.Free;
  FCalc.Free;
end;

function PriceCompare(Item1, Item2: Pointer): Integer;
begin
  result := TResult(Item1).totalcharge - TResult(Item2).totalcharge;
end;

procedure TSkyPerfecForm.CalcButtonClick(Sender: TObject);
begin
  Calculate;
end;

procedure TSkyPerfecForm.Calculate;
  procedure show_result( request_channels: TChannels; result: TResult; rank: integer );
  const
    HeadLabel = '#%d: v %d~';
    PackLabel = 'E%s %d~ %d(%s)';
    ChannelLabel = 'E%dch %s %d~';
    ServiceLabel = 'E%s { %d~';
  var
    i: integer;
    c: integer;
    s: string;
    count: integer;
    channel_packs: array of TPack;
    li: boolean;
    ch: TChannel;
    pack: TPack;
    ic: integer;
    packchannels: TIntSet;
  begin
    // e`lɏpbN蓖Ă
    SetLength( channel_packs, Length(request_channels) );
    for c := 0 to Length(request_channels)-1 do
      channel_packs[c] := result.GetAssignedPack(request_channels[c]);

    // z
    ResultView.Lines.Append( Format(HeadLabel, [rank+1, result.totalcharge]) );

    // T[rXƂ̊{
    for i := 0 to FCalc.ServiceCount-1 do
    begin
      if result.Needs(FCalc.Services[i]) then
        ResultView.Lines.Append( Format(ServiceLabel, [FCalc.Services[i].name, FCalc.Services[i].charge]) );
    end;

    packchannels := TIntSet.Create;

    // Limited, pbN\
    for li := false to true do
    begin
      for i := 0 to result.PackCount-1 do
      begin
        pack := result.Packs[i];
        if (pack.Limit > 0) <> li then
        begin
          continue;
        end;

        packchannels.Clear;
        if not pack.Limited then
        begin
          ic := 0;
          while pack.NextChannel(ic) do
            packchannels.Add(ic);
        end;

        s := '';
        count := 0;
        for c := 0 to Length(request_channels)-1 do
        begin
          if channel_packs[c] = pack then
          begin
            s := s + IntToStr(request_channels[c].DisplayChannel) + ' ';
            Inc(count);
            packchannels.Remove(request_channels[c].Num);
          end;
        end;

        if packchannels.First(ic) then
        begin
          s := s + '(';
          repeat
            s := s + '+' + IntToStr(ic);
          until not packchannels.Next(ic);
          s := s + ')';
        end;

        if pack.Limit > 0 then
        begin
          if pack.Limit < count then
          begin
            ResultView.Lines.Append('out of limit??');
          end;
        end;
        // s, count́ApackɊ܂܂邱ƂɂȂNGXg`lԍXgƁA
        ResultView.Lines.Append( Format(PackLabel, [pack.name, result.GetCharge(pack), count, s]) );
      end;
    end;
    packchannels.Free;

    // Pƃ`l\
    for c := 0 to Length(request_channels) {result.RestChannelCount} -1 do
    begin
      ch := request_channels[c]; //result.RestChannels[c];
      if channel_packs[c] = nil then
        ResultView.Lines.Append(
          Format(ChannelLabel,[ch.DisplayChannel, ch.name, result.GetCharge(ch)] )
      );
    end;
    ResultView.Lines.Append('');
  end;

  procedure show_results( max_count: integer);
  var
    i: integer;
    j: integer;
    next_ch: integer;
    temp_ch: TChannel;
    channels: TChannels;
    iResult: TResult;
    rank: integer;
    last: integer;
  begin
    SetLength(channels, FRequest.GetChannelCount);
    for i := 0 to Length(channels)-1 do
      channels[i] := FRequest.GetChannels(0, i);

    // channels[]channelԍŃ\[g /
    for i := 0 to Length(channels)-1 do
    begin
      next_ch := i;
      for j := i to Length(channels)-1 do
      begin
        if channels[j].Num < channels[next_ch].Num then
        begin
          next_ch := j;
        end;
      end;
      if next_ch <> i then
      begin
        temp_ch := channels[i];
        channels[i] := channels[next_ch];
        channels[next_ch] := temp_ch;
      end;
    end;

    // TotalChargeranktāAɕ\
    // FResults.Items[]TotalChargeňsortς݂ł̂
    // rank͓l𑵂邱Ƃŕt
    last := min(FResults.Count-1, max_count - 1);
    for i := last downto 0 do
    begin
      iResult := FResults.Items[i] as TResult;
      rank := i;
      while (rank > 0) and ((FResults.Items[rank-1] as TResult).TotalCharge = iResult.TotalCharge) do
        Dec(rank);
      show_result( channels, iResult, rank );
    end;
  end;
var
  start: Cardinal;
  variation: integer;
  aborted: boolean;
begin
  ResultView.Clear;
  Update;
  aborted := false;

  if FResults = nil then
  begin
    ResultView.Lines.Append('Calculating...');

    Enabled := false;
    ProgressDialog.Start(FRequest.GetChannelVariationCount);

    start := timeGetTime;

    FResults := TObjectList.Create;
    FResults.OwnsObjects := true;

    for variation := 0 to FRequest.GetChannelVariationCount-1 do
    begin
      ProgressDialog.StepIt;
      if ProgressDialog.Stopped then
      begin
        ResultView.Lines.Append('Abort.');
        aborted := true;
        break;
      end;
      FCalc.Enumerate( FResults, FRequest, variation );
    end;

    ResultView.Lines.Append('Elapsed time: ' + IntToStr(timeGetTime - start) + 'ms.');

    ResultView.Lines.Append('Sorting...');
    FResults.Sort(PriceCompare);

    Enabled := true;
    ProgressDialog.Hide;
  end;

  ResultView.Lines.Append('Total Results: ' + IntToStr(FResults.Count) + '.');
  ResultView.Lines.Append('');
  show_results(SpinEdit1.Value);

  if aborted then
  begin
    FreeAndNil(FResults);
  end;
end;

function TSkyPerfecForm.MakeHint(ch: TChannel): string;
var
  found: boolean;
  i: integer;
begin
  if ch = nil then
  begin
    result := '';
    exit;
  end;

  result := 'E^pbNEZbg';
  found := false;
  for i := 0 to FCalc.PackCount-1 do
  begin
    if FCalc.Packs[i].Contains( ch.Num ) and (FCalc.Packs[i].charge > 0) then
    begin
      result := result + #13#10 + FCalc.Packs[i].name + '  \' + IntToStr(FCalc.Packs[i].charge);
      found := true;
    end;
  end;
  if not found then
    result := 'E^pbNȂ';

  result := ch.name + ' [' + ch.Service.Name + ']' + #13#10 + result;
end;

procedure TSkyPerfecForm.ListView1SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
var
  s: string;
  ch: TChannel;
begin
  if csDestroying in ComponentState then
    Exit;

  if Item = nil then
  begin
    PackMemo.Clear;
    Exit;
  end;

  // assign a Hint
  ch := TChannel(Item.Data);
  s := MakeHint(ch);
  PackMemo.Lines.Text := s;
end;

procedure TSkyPerfecForm.ListView1Compare(Sender: TObject; Item1, Item2: TListItem;
  Data: Integer; var Compare: Integer);
  function GetCh(channel: TChannel): integer;
  begin
    result := channel.DisplayChannel;
    //result := channel.ch;
    //if channel.link_ch <> 0 then
    //  result := channel.link_ch;
  end;
  function CompareCh(ch1, ch2: TChannel): integer;
  begin
    result := GetCh(ch1) - GetCh(ch2);
    if result = 0 then
      result := ch1.Num - ch2.Num;
  end;
  function CompareService(ch1, ch2: TChannel): integer;
  begin
    result := CompareStr(Item1.SubItems[0], Item2.SubItems[0]);
  end;
var
  ch1, ch2: TChannel;
const
  colCh = 0;
  colService = 1;
  colGenre = 2;
  colChannelName = 3;
  colCharge = 4;
begin
  ch1 := TChannel(item1.Data);
  ch2 := TChannel(item2.Data);
  Compare := 0;
  case FListView1SortKey of
  colCh:
    Compare := CompareCh(ch1, ch2);
  colService:
    begin
      Compare := CompareService(ch1, ch2);
      if Compare = 0 then
        Compare := ch1.Num - ch2.Num;
    end;
  colGenre:
    begin
      Compare := CompareStr(ch1.Genre, ch2.Genre);
      if Compare = 0 then
        Compare := CompareStr(ch1.GetName, ch2.GetName);
    end;
  colChannelName:
    begin
      Compare := CompareStr(ch1.GetName, ch2.GetName);
      if Compare = 0 then
        Compare := CompareService(ch1, ch2);
    end;
  colCharge:
    Compare := ch1.Charge - ch2.Charge;
  end;
  if Compare = 0 then
    Compare := CompareCh(ch1, ch2);
end;

procedure TSkyPerfecForm.UpdateSelCount;
var
  i: integer;
  s: integer;
  selcount: integer;
  service: TService;
  total_selcount, total_count: integer;
begin
  if FUpdatingListViews <> 0 then
    Exit;
  total_selcount := 0;
  total_count := 0;
  for s := 0 to FCalc.ServiceCount-1 do
  begin
    service := FCalc.Services[s];
    selcount := 0;
    for i := 0 to service.ChannelCount-1 do
      if FRequest.GetRequest(service.Channels[i]) <> DontCare then
        Inc(selcount);

    if ListView2.Items.Count > s then
      if ListView2.Items[s].SubItems.Count > 1 then
        ListView2.Items[s].SubItems[1] := IntToStr(selcount) + '/' + IntToStr(service.ChannelCount);

    if FRequest.GetServiceEnabled(service) then
    begin
      Inc(total_selcount, selcount);
      Inc(total_count, service.ChannelCount);
    end;
  end;

  SelCountLabel.Caption := IntToStr(total_selcount) + '/' + IntToStr(total_count);

  CalcButton.Enabled := (total_selcount > 0);

  if FResults <> nil then
  begin
    FreeAndNil(FResults);
  end;
end;

procedure TSkyPerfecForm.ResetButtonClick(Sender: TObject);
var
  i: integer;
begin
  ListView1.Items.BeginUpdate;
  for i := 0 to ListView1.Items.Count -1 do
  begin
    if ListView1.Items[i].Checked then
      ListView1.Items[i].Checked := false;
  end;
  ListView1.Items.EndUpdate;
  UpdateSelCount;
end;

procedure TSkyPerfecForm.ListView1Change(Sender: TObject; Item: TListItem;
  Change: TItemChange);
var
  ch: TChannel;
begin
  if csDestroying in ComponentState then
    Exit;

  if Change = ctState then
  begin
    ch := TChannel(Item.Data);
    if ch <> nil then
    begin
      if Item.Checked then
        FRequest.SetRequest(ch, AnyService)
      else
        FRequest.SetRequest(ch, DontCare);
      UpdateSelCount;
    end;
  end;
end;

procedure TSkyPerfecForm.DumpPacks;
  procedure DumpPack( pack: TPack; level: integer );
  var
    i: integer;
  begin
    ResultView.Lines.Append( StringOfChar(' ', level) + pack.name + ' ' + IntToStr(pack.charge) );
    for i := 0 to Length(pack.items)-1 do
    begin
      if pack.items[i] is TChannel then
      begin
        //ResultView.Lines.Append( StringOfChar(' ', level + 2) + pack.items[i].name )
      end
      else
        DumpPack( TPack(pack.items[i]), level + 2 );
    end;
  end;
var
  i: integer;
begin
  for i := 0 to FCalc.PackCount-1 do
  begin
    DumpPack( FCalc.Packs[i], 0 );
  end;
end;

procedure TSkyPerfecForm.AddLine(s: string);
begin
//  OutputDebugString(PChar(s));
  ResultView.Lines.Append( s );
end;

procedure TSkyPerfecForm.ListView2Change(Sender: TObject; Item: TListItem;
  Change: TItemChange);
var
  service: TService;
begin
  if csDestroying in ComponentState then
    Exit;

  if Change = ctState then
  begin
    service := TService(Item.Data);
    if service <> nil then
    begin
      FRequest.SetServiceEnabled(service, Item.Checked);
      UpdateChannelListView;
      UpdateSelCount;
    end;
  end;
end;

procedure TSkyPerfecForm.UpdateServiceListView;
var
  i: integer;
  service: TService;
  listitem: TListItem;
begin
  if csDestroying in ComponentState then
    Exit;

  BeginUpdateListViews;
  try
    ListView2.Items.BeginUpdate;
    try
      for i := 0 to FCalc.ServiceCount-1 do
      begin
        service := FCalc.Services[i];
        listitem := ListView2.Items.Add;
        listitem.Caption := service.name;
        listitem.SubItems.Add( '\'+IntToStr(service.charge) );
        listitem.SubItems.Add( IntToStr(service.ChannelCount) );
        listitem.Data := service;
        listitem.Checked := FRequest.GetServiceEnabled(service);
      end;
    finally
      ListView2.Items.EndUpdate;
    end;
    ListView2.AlphaSort;
  finally
    EndUpdateListViews;
  end;
end;

procedure TSkyPerfecForm.UpdateChannelListView;
var
  si: integer;
  service: TService;
  i: integer;
  ch: TChannel;
  listitem: TListItem;
begin
  if csDestroying in ComponentState then
    Exit;

  BeginUpdateListViews;
  try
    ListView1.Items.BeginUpdate;
    ListView1.Items.Clear;
    try
      for si := 0 to FCalc.ServiceCount-1 do
      begin
        service := FCalc.Services[si];
        if not FRequest.GetServiceEnabled(service) then
          continue;

        for i := 0 to service.ChannelCount-1 do
        begin
          ch := service.Channels[i];
          listitem := ListView1.Items.Add;
          listitem.Caption := IntToStr(ch.DisplayChannel);
          listitem.SubItems.Capacity := 5;
          listitem.SubItems.Add( ch.Service.ShortName );
          listitem.SubItems.Add( ch.genre );
          listitem.SubItems.Add( ch.name );
          listitem.Data := ch;
          listitem.Checked := false;
          if ch.charge > 0 then
            listitem.SubItems.Add( '\'+IntToStr(ch.charge) )
          else
            listitem.SubItems.Add( 'pbN' );

          if FRequest.GetRequest(ch) <> DontCare then
            listitem.Checked := true;
        end;
      end;
    finally
      ListView1.Items.EndUpdate;
    end;
    ListView1.AlphaSort;
  finally
    EndUpdateListViews;
  end;
end;

procedure TSkyPerfecForm.BeginUpdateListViews;
begin
  Inc(FUpdatingListViews);
end;

procedure TSkyPerfecForm.EndUpdateListViews;
begin
  Dec(FUpdatingListViews);
  if FUpdatingListViews = 0 then
    UpdateSelCount;
end;

procedure TSkyPerfecForm.ListView1InfoTip(Sender: TObject; Item: TListItem;
  var InfoTip: String);
begin
  if csDestroying in ComponentState then
    Exit;

  InfoTip := MakeHint( TChannel(Item.Data) );
end;

procedure TSkyPerfecForm.SetSort( column: integer );
begin
  if column = FListView1SortKey then Exit;
  FListView1SortKey := column;
  ListView1.AlphaSort;
end;

procedure TSkyPerfecForm.ListView1ColumnClick(Sender: TObject;
  Column: TListColumn);
begin
  SetSort(Column.Index);
end;

end.
